#pragma once

#define DEF_MEMORECV_LIST_BG_COLOR				Color(255, 255, 255, 255)
#define DEF_MEMORECV_LIST_BGOUTLINE_COLOR		Color(255, 223, 225, 232)

#define DEF_MEMORECV_LIST_FONT_NAME				(g_defaultFontFaceName)
#define DEF_MEMORECV_LIST_FILE_FONT_HEIGHT		(9)
#define DEF_MEMORECV_LIST_FILE_FONT_COLOR		Color(255, 34, 34, 34)
#define DEF_MEMORECV_LIST_FILE_FONT_STYLE		(FontStyleRegular)

#define DEF_MEMORECV_LIST_INIT_GAP_X			(1)
#define DEF_MEMORECV_LIST_IMG_POS_LEFT_X		(20)
#define DEF_MEMORECV_LIST_IMG_POS_TOP_Y			(1)
#define DEF_MEMORECV_LIST_ITEM_HEIGHT			(22)
#define DEF_MEMORECV_LIST_IMG_NAME_GAP_X		(5)
#define DEF_MEMORECV_LIST_SIZE_WIDTH			(150)
#define DEF_MEMORECV_LIST_SIZE_PROG_GAP_X		(15)

#define DEF_MEMORECV_LIST_SCROLL_SIZE			(20)

#define ID_MEMORECV_SCROLLBAR					(0xA031)

// CMemoRecvAttachList

class CMemoRecvAttachList : public CWnd
{
	DECLARE_DYNAMIC(CMemoRecvAttachList)

public:
	CMemoRecvAttachList();
	virtual ~CMemoRecvAttachList();

public:
	typedef enum _memorecv_file_status
	{
		EMEMORECV_READY = 0,
		EMEMORECV_PAUSE,
		EMEMORECV_RECVING,
		EMEMORECV_COMPLETE,
		EMEMORECV_CANCEL
	} EMEMORECV_FILE_STATUS;

	typedef struct _memorecv_file_item
	{
		CRect					rtItem;
		CRect					rtImgFile;
		CString					strName;
		CString					strShowName;
		CSize					szName;
		CRect					rtName;
		CString					strDownloadURL;		
		ULONGLONG				dwTotalSize;
		ULONGLONG				dwCurSendSize;
		CString					strSize;
		CRect					rtSize;
		CRect					rtImgDownload;
		_memorecv_file_status	eStatus;
		BOOL					bHover;
		BOOL					bDown;

		_memorecv_file_item()
		{
			rtItem.SetRectEmpty();
			rtImgFile.SetRectEmpty();

			strName = _T("");
			strShowName = _T("");
            szName.SetSize(0, 0);
			rtName.SetRectEmpty();
			strDownloadURL = _T("");

			dwTotalSize = 0;
            dwCurSendSize = 0;

			strSize = _T("");
			rtSize.SetRectEmpty();

			rtImgDownload.SetRectEmpty();

			eStatus = EMEMORECV_READY;
			bHover = FALSE;
			bDown = FALSE;
		}
	} MEMORECV_FILE_ITEM, *PMEMORECV_FILE_ITEM;

	// BG
	Image*						m_pImgBG;
	Image*						m_pImgFile;
	Image*						m_pImgDownload;

	ULONGLONG					m_dwTotalSize;

	Color						m_crBG;
	Color						m_crOutline;

	void						SetImgBGPath(CString strFileName);
	void						SetImgFilePath(CString strFileName);
	void						SetImgDownloadPath(CString strFileName);

	ULONGLONG					GetTotalFileSize()								{ return m_dwTotalSize; }

	// font
	WCHAR						m_wszFontName[64];
	REAL						m_nFontHeight;
	FontStyle					m_fontStyle;
	Color						m_crText;

	void						SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);

	// dimension
	CRect						m_rtWnd;

	// child
	CPtrArray					m_ptrArFileItem;

	void						ClearFileItemAll();
	_memorecv_file_item*		AllocFileItem(CString strPath, CString strName, ULONGLONG dwFileSize);	
	BOOL						AddFileItem(CString strPath, CString strName, ULONGLONG dwFileSize);
	void						RecalcFileItem();
	int							GetFileItemCount()								{ return m_ptrArFileItem.GetCount(); }
	CString						GetFileItemDownloadURL(int nIdx);
	CString						GetFileItemName(int nIdx);
	ULONGLONG					GetFileItemTotalSize(int nIdx);
	ULONGLONG					GetFileItemCurRecvSize(int nIdx);
	ULONGLONG					GetFileItemTotalSizeAll();
	ULONGLONG					GetFileItemCurRecvSizeAll();
	void						DownloadFileItem(_memorecv_file_item* pFileItem);

	// scroll
	CScrollBar					m_wndScrollBar;
	CRect						m_rtScrollBar;

	int							m_nScrollPageSize;
	int							m_nScrollOneSize;

	BOOL						ScrollItem(int nDiff);
	void						UpdateScrollInfo();
	void						SetScrollOneSize(int nSize)						{ m_nScrollOneSize = nSize; }
	void						RecalcPostFileItem(_memorecv_file_item* pFI, int nOffsetY);

	// tracking
	BOOL						m_bTracking;

//private:
//	void GetSaveAsPath(CString &folderName);

protected:
	DECLARE_MESSAGE_MAP()

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnSize(UINT nType, int cx, int cy);
};
